> ## Documentation Index
> Fetch the complete documentation index at: https://upstash-vector.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# List Events

> This endpoint returns a list of all recent events. 

## Response

<ResponseField name="cursor" type="string">
  The cursor to use for pagination, if empty, there are no more pages.
</ResponseField>

<ResponseField name="events" type="Array<Event>" required>
  <Expandable title="Event">
    <ResponseField name="error" type="string">
      only set if status is error
    </ResponseField>

    <ResponseField name="id" type="string" required>
      The id of the event.
    </ResponseField>

    <ResponseField name="messageId" type="string" required>
      The associated message id
    </ResponseField>

    <ResponseField name="nextDeliveryTime" type="int">
      The next scheduled time of the message
    </ResponseField>

    <ResponseField name="state" type="string" required>
      The state of the message at this point in time
    </ResponseField>

    <ResponseField name="taskId" type="string" required>
      The associated task id
    </ResponseField>

    <ResponseField name="time" type="int" required>
      Timestamp of this event in unix time (milliseconds)
    </ResponseField>

    <ResponseField name="url" type="string">
      The destination url, this is experimental and might be removed in the future
    </ResponseField>
  </Expandable>
</ResponseField>

<RequestExample>
  ```shell curl
  curl -X GET https://qstash.upstash.io/v1/events \
   -H "Authorization: Bearer <token>"
  ```
</RequestExample>

<ResponseExample>
  ```json 200
  {
    "cursor": "1686652644442-12",
    "events": [
      {
        "id": "12345"
        "time": "1686652644442",
        "messageId": "msg_123",
        "nextDeliveryTime": "1691172945",
        "state": "delivered",
        "taskId": "98765",
        "time": "1691170945"
        "url": "https://example.com",
      }
    ]
  }
  ```
</ResponseExample>
